<?php
/***************************************************************************\
 * 				SpipCatChat Salon de Chat autonome pour Spip               *
 *                                                                         *
 *  Copyright (c) 2014                                                     *
 *  Auteur original: Codden Claude			                               *
 *  Traduction anglais: Codden Emmanuel									   *
 *  Chat autonome sur la base de fichier TXT, utilisant les membres 	   *
 *  de la table spip_auteurs.                                              *
 *  Pour plus de details voir le fichier COPYING.txt. 					   *
 *  Ce programme est un logiciel libre distribue sous licence GNU/GPL.     *
\***************************************************************************/
header('Content-Type: text/html; charset=UTF-8');
//--On démarre la session
session_start(); $timer=time();
//------Les fichiers à inclure-----//
include('../lang/'.$_COOKIE['CATCHAT_LANG'].'.php');
include('../fonction/fonction.php');
include('../config/constante.php');
//------Les fichiers à inclure-----//
$chemin=constant('CATCHAT_DB').$_SESSION['catchatSelectCodeSalon'].'/'.$_SESSION['catchatSelectCodeSalon'];// Appel de la fonction de connexion à la base de données
$db = db_connect();/* On vérifie d'abord que le compte existe, si ce n'est pas le cas, on s'arrête, on supprime les sessions et on renvoie 0. */
$checkUser = $db->prepare("SELECT * FROM spip_auteurs WHERE id_auteur = :id AND login = :login ");
$checkUser->execute(array(
	'id' =>  $_SESSION['catchatid'],
	'login' =>  $_SESSION['catchatlogin']
));	
	 $countUser = $checkUser->rowCount();
	 $file_users=file_get_contents($chemin.'.js');
	 $file_users=json_decode($file_users);//Si l'utilisateur n'est pas invité à participer au salon, on l'éject
if($_SESSION['catchatPublic']==false && !in_array($_SESSION['catchatid'],$file_users))
	{
	unset( $_SESSION['catchattime'],
		   $_SESSION['catchatSelectMonSalon'], 
		   $_SESSION['catchatSelectNomSalon'],
		   $_SESSION['catchatPublic'],
		   $_SESSION['catchatAdmin'],
		   $_SESSION['catchatSelectCodeSalon']);
	}
if($countUser == 0 || empty($_SESSION['catchatid']) || empty($_SESSION['catchatlogin'])) 
	{// On indique qu'il y a une erreur de type unlog// donc que l'utilisateur connecté n'a pas de compte
	$json['error'] = 'unlog';// On supprime les sessions
	unset( $_SESSION['catchattime'],
		   $_SESSION['catchatid'],
	       $_SESSION['catchatlogin'],
		   $_SESSION['catchatSelectMonSalon'], 
		   $_SESSION['catchatSelectNomSalon'],
		   $_SESSION['catchatPublic'],
		   $_SESSION['catchatAdmin'],
		   $_SESSION['catchatSelectCodeSalon']);
	}
	else 
	{ $json['error'] = '0';// Si il n'y a aucune erreur
	}
$checkUser->closeCursor();// On termine la requête
if( filemtime($chemin.'.catchat')>($timer -5) || empty($_SESSION['catchatcache'.$_SESSION['catchatSelectCodeSalon']]) ){// Affichage de l'annonce 
	$json['annonce'] = html_entity_decode($_SESSION['catchatSelectNomSalon']);
	$json['messages']= '<table width="100%">';
	$i = 1;
	$prev = 0;
	$data_base=fopen($chemin.'.catchat','r');
	while (!feof($data_base)) {
		// Change la couleur dès que l'ID du membre est différent du précédent
		$data=json_decode(fgets($data_base));
		$date_message=$data[2];
		if($_SESSION['catchattime']  <= $date_message)
		{
		if($i != 1) {
			$idNew = $data[0];		
			if($idNew != $id) {
				if($colId == 1) {
					$color = 'class="alter"';
					$colId = 0;
				} else {
					$color = 'class="ego"';
					$colId = 1;
				}
				$id = $idNew;
			} else
				$color = $color;
		} else {
			$color = 'class="ego"';
			$id = $data[0];
			$colId = 1;
		}
		$text .= '<tr><td style="width:15%" valign="top">';
		
			if(($lienLogo=logo_auteur_chat($id)) && LOGO_CHAT)
			{	
				$timeCode=$timer.date('Hs', $date_message).$id.$i;
				$logo='<div class="Wolog'.$timeCode.'" id="cadre" style="display:none"><img  class="logouser"  src="'.$lienLogo.'"></div>';
			}
		// Si le dernier message est du même membre, on écrit pas de nouveau son pseudo
		if($prev != $data[0])
		{// contenu du message	
			$text .= '<span  onmouseout="logoSpipHidden(\'Wolog'.$timeCode.'\');" onmouseover="logoSpipShow(\'Wolog'.$timeCode.'\');return false;" style="CURSOR:POINTER">';
			$text .= '<span class="clock">'.date('H:i', $date_message).'</span>';
			$text .= '&nbsp;<span '.$color.'>'.$data[1].$logo.'</span>';
			$text .= '</span>';
		}
		$text .= '</td>';			
		$text .= '<td style="width:85%;padding-left:10px;" valign="top">&nbsp; ';
		$message = htmlspecialchars($data[3]); // On supprime les balises HTML
		$text .= $message;
		$text .= ' &nbsp;</td></tr>';
		unset($timeCode,$lienLogo,$logo);
		$i++;
		$prev = $data[0];
		$count=true;
		}	
	} /* On crée la colonne messages dans le tableau jsonqui contient l'ensemble des messages */
	$json['messages']=$text.'</table>';
if(!$count) { $json['messages'] = $_GLOBALS['lang']['aucun_message'];} $json=json_encode($json); 
$_SESSION['catchatcache'.$_SESSION['catchatSelectCodeSalon']] =$json; echo $json;// Encodage de la variable tableau json et affichage
}else{echo $_SESSION['catchatcache'.$_SESSION['catchatSelectCodeSalon']];}?>