<?php 
/***************************************************************************\
 * 				SpipCatChat Salon de Chat autonome pour Spip               *
 *                                                                         *
 *  Copyright (c) 2014                                                     *
 *  Auteur original: Codden Claude			                               *
 *  Traduction anglais: Codden Emmanuel									   *
 *  Chat autonome sur la base de fichier TXT, utilisant les membres 	   *
 *  de la table spip_auteurs.                                              *
 *  Pour plus de details voir le fichier COPYING.txt. 					   *
 *  Ce programme est un logiciel libre distribue sous licence GNU/GPL.     *
\***************************************************************************/

header('Content-Type: text/html; charset=UTF-8');
//------Les fichiers à inclure-----//
include('../fonction/fonction.php');
// Appel de la fonction de connexion à la base de données
$db = db_connect();
// On crée une requête pour rechercher un compte ayant pour nom, email, login 
$q = $db->prepare('SELECT nom , login ,  id_auteur , statut FROM spip_auteurs WHERE login LIKE :lettre OR nom LIKE :lettre LIMIT 5');
$q->execute(array(':lettre'=>$_GET[term].'%'));
$json=array();
//On recherche l'utilisateur dans une boucle
	while($d = $q->fetch())
	{			
		if(!empty($d['nom']) && $d['nom']!=$d['login'])
		{
		array_push( $json,array( "value"=>html_entity_decode(stripslashes($d['nom'])),"id"=> $d['id_auteur'] ) );
		}
		array_push( $json,array( "value"=>html_entity_decode(stripslashes($d['login'])),"id"=> $d['id_auteur'] ) );	
	}
// On termine la requête
$q->closeCursor();
//On retourne le résultat en JSON
echo json_encode($json); 
?>